#include <SPI.h>
//#include "DueTimer.h"
#include "Ilda.h"
#include <WInterrupts.h>

//some commands
#define  CMD_SET_WUPA           0x18        //DAC-Aдݲ¼Ĵ  +16λ
#define  CMD_SET_WUPB           0x19        //DAC-Aдݲ¼Ĵ  +16λ
#define  CMD_UPALL_DACS	   		  0x0F	      // 16λֻʱӼ

#define  CMD_SET_GAIN           0x02        //
#define  DATA_GAIN_1            0x0000      //DACB Gain=2,DACA Gain=2
#define  DATA_GAIN_2            0x0001      //DACB Gain=2,DACA Gain=1
#define  DATA_GAIN_3            0x0002      //DACB Gain=1,DACA Gain=2
#define  DATA_GAIN_4            0x0003      //DACB Gain=1,DACA Gain=1

#define  CMD_SET_POWER          0x20        //set DAc power up/down mode
#define  DATA_POWER_03          0x0003      //power up DAC-A and DAC-B

#define  CMD_RESET              0x28        //λDAC
#define  DATA_RESET_1           0x0000      //reset DAC_a and DAc_b input register and updata all DACs
#define  DATA_RESET_2           0x0001      //Reset all registers and update all DACs (Power-on-reset update

#define  CMD_LDAC               0x30        //set LDAC registers
#define  DATA_LDAC_1            0x0000      //LDACſDAC-A and DAC-Bݸ
#define  DATA_LDAC_2            0x0001      //LDACſDAC-Bݸ
#define  DATA_LDAC_3            0x0002      //LDACſDAC-Aݸ
#define  DATA_LDAC_4            0x0003      //LDACŲDAC-B and DAC-Bݸ

#define  CMD_IN_Ref             0x38        //Disable/Enable internal reference
#define  DATA_INRef_EN          0x0001      //ѡڲολ2DAC=2 λʱڲοǽֹ)
#define  DATA_INRef_DI          0x0000      //Disable internal reference and reset DACs to gain = 1

//defines for reset
#define SYSRESETREQ    (1<<2)
#define VECTKEY        (0x05fa0000UL)
#define VECTKEY_MASK   (0x0000ffffUL)
#define AIRCR          (*(uint32_t*)0xe000ed0cUL) // fixed arch-defined address
#define REQUEST_EXTERNAL_RESET (AIRCR=(AIRCR&VECTKEY_MASK)|VECTKEY|SYSRESETREQ)

#define LDAC 8
#define SYNC 4
#define CLR  12
 
volatile unsigned long LastTick = 0;
volatile unsigned long lastslice = 0;

volatile uint32_t  CountA = 32767;
volatile uint32_t  CountB = 32767;
volatile uint32_t  LastA = 0;
volatile uint32_t  LastB = 0;
byte check = 0;
volatile int cnt = 0;

int mosi = 75;          //assigning variables to pins
int sck = 76;
int miso = 74;

#define YStepPin 5
#define XStepPin 2
#define YDirPin  9
#define XDirPin  3
#define YHome 13
#define XHome 11
#define ButtonPin 12

//test pattern variables
bool InTest = false;
int TestPattern = 0;
bool first = true;
double CircAngle = 0;
double dist = 25; //initial distance increment on pattern.
double CircInc = .01;
int PatternStage = 0;
int SquareStage = 0;
bool Blink = true;
int blank= 0;
int lastcount = 0;
int ildacnt = 0;
int16_t Sines[4000];
volatile bool OnHomeX = false;
volatile bool OnHomeY = false;
bool lasthomex = false;
bool lasthomey = false;

inline void digitalWriteDirect(int pin, boolean val) {
	if (val) g_APinDescription[pin].pPort->PIO_SODR = g_APinDescription[pin].ulPin;
	else    g_APinDescription[pin].pPort->PIO_CODR = g_APinDescription[pin].ulPin;
}

inline int digitalReadDirect(int pin) {
	return !!(g_APinDescription[pin].pPort->PIO_PDSR & g_APinDescription[pin].ulPin);
}
 
void PIOB_Handler(void) {
	uint32_t isr = PIOB->PIO_ISR;
	//if (isr & 0B10000000000000000000000000) //pin B.25 
	//{  //pin 19  do something

		XStepISR();
	//}
}
void PIOC_Handler(void) {
	uint32_t isr = PIOC->PIO_ISR;
	//if (isr & 0B10000000000000000000000000) //pin C.25
	//{  //pin 19  do something
		YStepISR();
	//}
}


void SetupTestPattern()
{
	
	PatternStage = 1;
}

void ResetTestPattern()
{
	PatternStage = 0;
	SquareStage = 0;
	CircAngle = .000;
	ildacnt = 0;
}

 
int lasttime;

void setup()
{

	pinMode(LED_BUILTIN, OUTPUT);
	pinMode(LDAC, OUTPUT);
	pinMode(SYNC, OUTPUT);
	pinMode(CLR, OUTPUT);

	pinMode(mosi, OUTPUT);     //Configuring pins as input and output
	pinMode(sck, OUTPUT);
	pinMode(miso, INPUT);

	pinMode(XStepPin, INPUT);
	digitalWrite(XStepPin, LOW);
	pinMode(YStepPin, INPUT);
	digitalWrite(YStepPin, LOW);

	pinMode(XDirPin, INPUT);
	digitalWrite(XDirPin, HIGH);
	pinMode(YDirPin, INPUT);
	digitalWrite(YDirPin, HIGH);

	pinMode(XHome, OUTPUT);
	digitalWrite(XHome, LOW);
	pinMode(YHome, OUTPUT);
	digitalWrite(YHome, LOW);
		
	digitalWrite(mosi, LOW);
	digitalWrite(SYNC, HIGH);
	digitalWrite(LDAC, HIGH);
	digitalWrite(CLR, LOW);
	digitalWrite(CLR, HIGH);

	SPI.begin(SYNC);                   // waking up SPI bus
	SPI.setDataMode(SYNC, SPI_MODE3);  //setting mode for clk phase & pol
	SPI.setBitOrder(SYNC, MSBFIRST);   // setting bit order for transfer
	SPI.setClockDivider(SYNC,8);     //setting clock to 20 MHz
	//setup a pushbutton to select test modes.

	pinMode(ButtonPin, INPUT);
	digitalWrite(ButtonPin, HIGH);    // Enable pulldown resistor 
	if (digitalRead(ButtonPin) == LOW) //see if test button is being held
		InTest = true;

	//setup some interrupts for the step functions
	//pins 2 & 5
	pinMode(XStepPin, INPUT);
	digitalWrite(XStepPin, LOW);    // Enable pulldown resistor 
	pinMode(YStepPin, INPUT);
	digitalWrite(YStepPin, LOW);    // Enable pulldown resistor 
	if (!InTest)
	{
		attachInterrupt(XStepPin, XStepISR, RISING);
		attachInterrupt(YStepPin, YStepISR, RISING);
	}
	if (InTest)
	{
		TestPattern = 0;
		//build sine tables
		for (int x = 0; x < 4000; x++)
		{
			double ang = x * .001570796;
			Sines[x] = (sin(ang) * 32767) + 32768;
		}
		//calculate test pattern params
		double circ = 2 * 3.1415926 * 16384.0; //circumferance of full circle.
		dist = 150; //initial distance increment on pattern.
		CircInc = (dist / circ) * 4000;
		if (CircInc < .0001)
			CircInc = .0001;
		
	}
	//setup the dacs.
	WriteCmd(CMD_SET_POWER, DATA_POWER_03);
	WriteCmd(CMD_SET_GAIN, DATA_GAIN_1);
	WriteCmd(CMD_LDAC, DATA_LDAC_1);
	WriteCmd(CMD_IN_Ref, DATA_INRef_EN);

	lasttime = millis();
}

int Skip = 0;
unsigned long looptime;
unsigned long lastpat;
unsigned long loopslice;
int lastcnt = 0;
int lastsec = 0;
int buttoncount = 0;
int daccnt = 0;
int errorcnt = 32768;

void loop()
{
 
	//throttle it.
	//loopslice = micros() - looptime;
	//if (loopslice < 10)
	//	return;
	while (1)
	{
		looptime = millis();
		//if (looptime - lasttime > 1)
		//{
		//	CountA = CountB = errorcnt;
		//	errorcnt -= 100;
		//	if (errorcnt < 16384)
		//		errorcnt = 32768;
		//}
		lasttime = looptime;
		DacHandler();


		/*
			if (looptime - lastsec > 2000)
			{
				lastsec = looptime;
				Serial.print(" LastDacsPerTwoSec: ");
				Serial.println(daccnt);
				daccnt = 0;
				Serial.print(" LastIntsPerTwoSec: ");
				Serial.println( cnt);
				Serial.print(" LastA: ");
				Serial.print( CountA );
				Serial.print(" LastB: ");
				Serial.println(CountB);
				cnt = 0;// seccnt = cnt;
				if (!InTest)
				{
					//perform a reset
					if (digitalRead(ButtonPin) == LOW) //see if test button is being held
						buttoncount++;
					else
						buttoncount = 0;
					if (buttoncount > 2)
					{
						Serial.println("Reset Commanded");
						digitalWrite(XHome, HIGH);
						digitalWrite(YHome, HIGH);
						delay(1000);
						RSTC->RSTC_CR = 0xA5000005;
						buttoncount = 0;
					}
				}
			}

		 */
		if (lasthomex != OnHomeX)
		{
			lasthomex = OnHomeX;
			digitalWriteDirect(XHome, lasthomex);
		}
		if (lasthomey != OnHomeY)
		{
			lasthomey = OnHomeY;
			digitalWriteDirect(YHome, lasthomey);
		}

		if (InTest)
		{

			if (looptime - lastpat < 3)
				return;
			lastpat = looptime;
			lastcount = cnt;
			//simple circle
			switch (PatternStage)
			{
			case(0):
				SetupTestPattern();
				break;
			case(1):
				CircleTest();
				break;
			case(2):
				//if( TestPattern == 1)
				PatternStage++;
				//else
				//SquareTest();
				break;
			case(3):
				ResetTestPattern();
				if (digitalRead(ButtonPin) == LOW) //see if test button is being held
					buttoncount++;
				else
					buttoncount = 0;
				if (buttoncount == 50000)
				{
					TestPattern++;     //cycle the test types.
					if (TestPattern > 2)
						TestPattern = 1;
					buttoncount = 0;
				}
				break;
			default:
				break;
			}

		}

	}
	  
 
}

void CircleTest()
{
	if (CircAngle >= 4000)
	{
		CircAngle = 0;
		PatternStage++;
		int isin = CircAngle;
		int icos = (isin + 1000) % 4000;
		CountA = Sines[icos];
		CountB = Sines[isin];
	}
	else
	{
		int isin = CircAngle;
		int icos = (isin + 1000) % 4000;
		CountA = Sines[icos];
		CountB = Sines[isin];
		CircAngle += CircInc;
 	}
}

void SquareTest()
{
    //if squarestage == 0, were at 64K in the X, 32768 in the Y
	CountA &= 0xffff;
	CountB &= 0xffff;
	switch (SquareStage)
	{
	case(0):
		//we're moving up. move B(y) to max
		if ((CountB + dist) >= 65535)
		{
			CountB = 65535;
			SquareStage++;
		}
		else
			CountB += dist;
		break;
	case(1):
		//now move back on A to zero.
		if (CountA < dist)
		{
			CountA = 0;
			SquareStage++;
		}
		else
			CountA -= dist;
		break;
	case(2):
		//now move B up to bototm
		if (CountB < dist)
		{
			CountB = 0;
			SquareStage++;
		}
		else
		{
			CountB -= dist;
		}
		break;
		
	case(3):
		//now move A across top
		if ((int)CountA + dist >= 65535)
		{
			CountA = 65535;
			SquareStage++;
		}
		else
			CountA += dist;
		break;
	case(4):
		//now move B down to center
		if ((int)CountB + dist >= 32768)
		{
			CountB = 32768;
			SquareStage++;
			PatternStage++;
		}
		else
			CountB += dist;
		break;
		 
    }
	 
	
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// INTERRUPT HANDLERS
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
void DacHandler()
{
	 
	daccnt++;
	//if (LastA != CountA && LastB != CountB)
	//{
	//	digitalWriteDirect(LDAC, HIGH);
	//	SendData(0, CountA);
	//	SendData(1, CountB);
	//	digitalWriteDirect(LDAC, LOW);
	//}
	//else
		if (LastA != CountA)
		{
	 		SendData(0, (uint16_t) (65535 - CountA));
	 	}
	if (LastB != CountB)
			{
		SendData(1, (uint16_t)CountB);
	 		}

 
}

void YStepISR()
{
	cnt++;
	if (!digitalReadDirect(YDirPin))
	{
		 
		if (CountA < 65531)
			CountA += 4;
		else
			CountA = 65535;
		OnHomeY = false;
	}
	else
	{
		if (CountA > 4)
			CountA-=4;
		else
		{
			OnHomeY = true;
			CountA = 0;
		}
		 
	}
}

void XStepISR()
{
	cnt++;
	if (!digitalReadDirect(XDirPin))
	{
		 
		if (CountB < 65531)
			CountB+=4;
		else
			CountB = 65535;
		OnHomeX = false;
	}
	else
	{
		if (CountB > 4)
			CountB-=4;
		else
		{
			OnHomeX = true;
			CountB = 0;
		}
	 
		 
	}

}

void WriteCmd(uint8_t cmd, uint16_t data)
{
	SPI.transfer(SYNC, cmd, SPI_CONTINUE);
	SPI.transfer(SYNC, data >> 8, SPI_CONTINUE);    // transfer values from 0 to 255
	SPI.transfer(SYNC, data);
}

void SendData(uint8_t _ch, uint16_t _dac)
{
	uint8_t cmd;

	if (_ch == 0)
	{
		cmd = CMD_SET_WUPA;
		if (_dac == 0)
			cmd = CMD_SET_WUPA;
		LastA = _dac;
	}
	else
	{
		cmd = CMD_SET_WUPB;
		LastB = _dac;
	}

	WriteCmd(cmd, _dac);

}


